

#ifdef WIN32
#if _MSV_VER < 1400
#include <ctype.h>
#define iswspace(C) my_iswspace(C)
static inline bool iswspace(wchar_t c)
{
	return c < 0x100 && isspace(c);
}
#else
#include <wctype.h>
#endif
#endif

#include "CombinePath.h"

static bool isfileseparator(int c)
{
	return c == '\\' || c == '/';
}


std::wstring CombinePath(wchar_t const *left, wchar_t const *right, wchar_t separator)
{
	while (iswspace(*left)) left++;
	while (iswspace(*right)) right++;
	if (isfileseparator(*right)) {
		return right;
	}
	size_t n = wcslen(left);
	if (n > 0 && isfileseparator(left[n - 1])) {
		n--;
	}
	std::wstring path(left, n);
	wchar_t tmp[2];
	tmp[0] = separator;
	tmp[1] = 0;
	path.append(tmp);
	path.append(right);
	return path;
}

std::string CombinePath(char const *left, char const *right, char separator)
{
	while (isspace(*left)) left++;
	while (isspace(*right)) right++;
	if (isfileseparator(*right)) {
		return right;
	}
	size_t n = strlen(left);
	if (n > 0 && isfileseparator(left[n - 1])) {
		n--;
	}
	std::string path(left, n);
	char tmp[2];
	tmp[0] = separator;
	tmp[1] = 0;
	path.append(tmp);
	path.append(right);
	return path;
}

std::wstring CombinePath(std::wstring const &left, std::wstring const &right, wchar_t separator)
{
	return CombinePath(left.c_str(), right.c_str(), separator);
}

std::string CombinePath(std::string const &left, std::string const &right, char separator)
{
	return CombinePath(left.c_str(), right.c_str(), separator);
}


