
#include "RadioTuner.h"

RadioTuner::RadioTuner()
{
	hComPort = INVALID_HANDLE_VALUE;
}

void RadioTuner::open(char const *path)
{
	if (hComPort != INVALID_HANDLE_VALUE) {
		CloseHandle(hComPort);
	}
	hComPort = CreateFile(path, GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hComPort != INVALID_HANDLE_VALUE) {
		DCB dcb;
		GetCommState(hComPort, &dcb);
		dcb.BaudRate = 9600;
		dcb.ByteSize = 8;
		dcb.Parity = NOPARITY;
		dcb.fParity = FALSE;
		dcb.StopBits = ONESTOPBIT;
		SetCommState(hComPort, &dcb);
	}
}

void RadioTuner::close()
{
	if (hComPort != INVALID_HANDLE_VALUE) {
		DWORD n;
		WriteFile(hComPort, "mute\r", 5, &n, 0);
		CloseHandle(hComPort);
		hComPort = INVALID_HANDLE_VALUE;
	}
}

void RadioTuner::tune_am(double kHz)
{
	if (hComPort == INVALID_HANDLE_VALUE) {
		return;
	}
	char tmp[100];
	sprintf(tmp, "%u\r", (int)kHz);
	DWORD n;
	WriteFile(hComPort, tmp, strlen(tmp), &n, 0);
	WriteFile(hComPort, "am\r", 3, &n, 0);
}

void RadioTuner::tune_fm(double MHz)
{
	if (hComPort == INVALID_HANDLE_VALUE) {
		return;
	}
	char tmp[100];
	sprintf(tmp, "%u\r", (int)(MHz * 100));
	DWORD n;
	WriteFile(hComPort, tmp, strlen(tmp), &n, 0);
	WriteFile(hComPort, "fm\r", 3, &n, 0);
}

