
#ifndef __Socket_h
#define __Socket_h

class Socket {
private:
	struct Privates;
	Privates *privates;
	void assign(Privates *p);
public:
	Socket()
		: privates(0)
	{
	}
	Socket(Socket const &r);
	~Socket();
	void operator = (Socket const &r);

	bool isvalid() const;

	bool socket(int af, int type, int protocol);
	bool connect(struct sockaddr const *name, int namelen);
	Socket accept(struct sockaddr *addr, int *addrlen);
	int send(void const *buf, int len, int flags);
	int recv(void *buf, int len, int flags);
	void close();

	int bind(const struct sockaddr *name, int namelen);
	int listen(int backlog);

	int setsockopt(int level, int optname, const char *optval, int optlen);

	bool sendtcp(void const *ptr, size_t len);
	bool recvtcp(void *ptr, size_t len);
};

#endif