
#include "html.h"
#include <sstream>
#include "sswrite.h"

std::string decode_html_entity(char const *ptr, size_t len)
{
	std::stringstream out;
	while (len > 0) {
		char c = *ptr;
		size_t span = 1;
		if (c == '&') {
			char const *p = ptr;
			char const *e = strchr(p, L';');
			if (e) {
				size_t n = e - p;
				if (strncmp(p, "&amp;", 5) == 0) {
					sswrite(&out, '&');
				} else if (strncmp(p, "&lt;", 4) == 0) {
					sswrite(&out, '<');
				} else if (strncmp(p, "&gt;", 4) == 0) {
					sswrite(&out, '>');
				} else if (strncmp(p, "&quot;", 6) == 0) {
					sswrite(&out, '\"');
				} else if (strncmp(p, "&apos;", 6) == 0) {
					sswrite(&out, '\"');
				} else if (strncmp(p, "&#", 2) == 0) {
					if (p[2] == 'x') {
						c = (char)strtol(p + 3, 0, 16);
						sswrite(&out, c);
					} else if (isdigit(p[2])) {
						c = (char)strtol(p + 2, 0, 10);
						sswrite(&out, c);
					}
				}
				span = e - p + 1;
			}
		} else {
			sswrite(&out, c);
		}
		ptr += span;
		len -= span;
	}
	return out.str();
}

