
#include "html.h"
#include <sstream>
#include "sswrite.h"

std::wstring decode_html_entity(wchar_t const *ptr, size_t len)
{
	std::wstringstream out;
	while (len > 0) {
		wchar_t c = *ptr;
		size_t span = 1;
		if (c == '&') {
			wchar_t const *p = ptr;
			wchar_t const *e = wcschr(p, L';');
			if (e) {
				size_t n = e - p;
				if (wcsncmp(p, L"&amp;", 5) == 0) {
					sswrite(&out, L'&');
				} else if (wcsncmp(p, L"&lt;", 4) == 0) {
					sswrite(&out, L'<');
				} else if (wcsncmp(p, L"&gt;", 4) == 0) {
					sswrite(&out, L'>');
				} else if (wcsncmp(p, L"&quot;", 6) == 0) {
					sswrite(&out, L'\"');
				} else if (wcsncmp(p, L"&apos;", 6) == 0) {
					sswrite(&out, L'\"');
				} else if (wcsncmp(p, L"&#", 2) == 0) {
					if (p[2] == L'x') {
						c = (wchar_t)wcstol(p + 3, 0, 16);
						sswrite(&out, c);
					} else if (isdigit(p[2])) {
						c = (wchar_t)wcstol(p + 2, 0, 10);
						sswrite(&out, c);
					}
				}
				span = e - p + 1;
			}
		} else {
			sswrite(&out, c);
		}
		ptr += span;
		len -= span;
	}
	return out.str();
}
