
#ifndef __widestringwriter_h
#define __widestringwriter_h

#include <vector>
#include <string>

class widestringwriter : public soramimi::encoding::wcswriter {
private:
	std::vector<uchar_t> buffer;
public:
	widestringwriter()
	{
		buffer.reserve(1024);
	}
	virtual void put(uchar_t c)
	{
		buffer.push_back(c);
	}
	std::wstring str() const
	{
		if (buffer.empty()) {
			return std::wstring();
		}
		return std::wstring((wchar_t const *)&buffer[0], buffer.size());
	}
	void clear()
	{
		buffer.clear();
		buffer.reserve(1024);
	}
};

#endif
