
#ifndef __ShoutShark_h
#define __ShoutShark_h

#include <string>
#include "httpserver.h"
#include "RadioTuner.h"

class ShoutShark {
private:
	struct Privates;
	Privates *privates;
	http_status_t const *http_get_handler(std::string const &uri, httpserver::http_request_t *request, httpserver::http_response_t *response);
	static http_status_t const *http_get_handler_(void *cookie, std::string const &uri, httpserver::http_request_t *request, httpserver::http_response_t *response);
	void SetRadioDevice(int device, std::string const &comport);
	void SetServerInfo(std::string const &address, int port, std::string const &password, bool restart);
	void SavePresets();
	std::string GetDescription();
public:
	ShoutShark();
	~ShoutShark();
	void TuneAM(double kHz);
	void TuneFM(double MHz);
	void Main(bool as_service);
};


#endif

